#property  copyright "Copyright  2005, Yura Prokofiev"
#property  link      "Yura.prokofiev@gmail.com <------ thanks Altered by Perky" 

#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Black
#property  indicator_color2  LimeGreen
#property  indicator_color3  Red
#property  indicator_width2  4
#property  indicator_width3  4
 
extern int  FastADRsi=3;
extern int  slowADRsi=14;
extern bool AlertON  = false;
extern bool SoundON  = false;
extern bool ShowSignal_Lines = true;
extern int  WidthLine=0;
extern int  Line_style = 3;
extern string LineTypes  = "1 = full lines + times / 2 = full lines";  
extern string LineTypes2 = "3 = short lines chart only / 4 = arrows"; 
extern int  Line_displayType = 3; 

extern color colorup=MediumSeaGreen;
extern color colordown=Salmon;
double         ExtBuffer0[];
double         ExtBuffer1[];
double         ExtBuffer2[];
int count=0;
int barz=0;
int i,TimeFrame;
string tf;

#define SignalName "adrsicvdv"

int init()
  {
   
   
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   IndicatorDigits(Digits+1);

   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);

   IndicatorShortName("AdrsiCVDV v6");
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   
     	switch(TimeFrame)
	{
		case 1:		tf=" M1";  break;
		case 5:		tf=" M5";  break;
		case 15:		tf=" M15"; break;
		case 30:		tf=" M30"; break;
		case 60:		tf=" H1";  break;
		case 240:	tf=" H4";  break;
		case 1440:	tf=" D1";  break;
		case 10080:	tf=" W1";  break;
		case 43200:	tf=" MN1"; break;
		default:	  {TimeFrame = Period(); init(); return(0);}
	
	}

   return(0);
  }


int deinit(){
DeleteLines();

return(0);}

int start()
  {
  
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current;
   

   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

Comment (limit);
   for(i=0; i<limit; i++)
    {  
      ExtBuffer0[i]=(iCustom(NULL, 0, "3 RSI Adaptive EMAs",FastADRsi,0,i))-(iCustom(NULL, 0, "3 RSI Adaptive EMAs",slowADRsi,14,0,i));
         
      
      
    }


   bool up=true;
  
  for(i=limit-2; i>=0; i--)
     {
      current=ExtBuffer0[i];
      prev=ExtBuffer0[i+1];
     
      
        if (ShowSignal_Lines) {
           DeleteLine(Time[i]);
        if(ExtBuffer0[i]>0&&ExtBuffer0[i]>0 && ExtBuffer0[i+1]<0) DrawLine(i,CornflowerBlue,233,false);
        if(ExtBuffer0[i]<0&&ExtBuffer0[i]<0 && ExtBuffer0[i+1]>0) DrawLine(i,DarkOrange,234,true);
        }
         
      if (((current<0)&&(prev>0))||(current<0))   up= false;    
      if (((current>0)&&(prev<0))||(current>0))   up= true;      
      
      if(!up)
        {
         ExtBuffer2[i]=current;
         ExtBuffer1[i]=0.0;
        }
        
       else
         {
          ExtBuffer1[i]=current;
          ExtBuffer2[i]=0.0;
         }
         
        double alertprice = MarketInfo(Symbol(),MODE_BID); 
        static int direction1;
        if(AlertON && direction1!=1 && ExtBuffer0[i]>0&&ExtBuffer0[i]>0 && ExtBuffer0[i+1]<0){if (BarChanged()){direction1 = 1;Alert("RSI Adaptive MAs : "+Symbol()+"  "+tf+" : UP  @ "+DoubleToStr(alertprice,Digits));}}
        
        if(AlertON && direction1!=-1 && ExtBuffer0[i]<0&&ExtBuffer0[i]<0 && ExtBuffer0[i+1]>0){if (BarChanged()){direction1 = -1;Alert("RSI Adaptive MAs : "+Symbol()+"  "+tf+" : DN  @ "+DoubleToStr(alertprice,Digits));}}
        
        static int direction2;
        if(SoundON && direction2!=1 && ExtBuffer0[i]>0&&ExtBuffer0[i]>0 && ExtBuffer0[i+1]<0){if (BarChanged()){direction1 = 2;PlaySound("news.wav");}}
        
        if(SoundON && direction2!=-1 && ExtBuffer0[i]<0&&ExtBuffer0[i]<0 && ExtBuffer0[i+1]>0){if (BarChanged()){direction1 = -2;PlaySound("news.wav");}}
        
     }

   return(0);
  }
  
     
void DrawLine(int shift,color theColor,int theCode,bool up)
{
   string name = ":"+Time[shift];
         if(Line_displayType==3){int TYPE=OBJ_TREND;}
         else {TYPE=OBJ_VLINE;}
         if(Line_displayType==3 || Line_displayType==2 || Line_displayType==1){
         ObjectCreate(name,TYPE,0,Time[shift],1,Time[shift],100);  
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,WidthLine);
         ObjectSet(name,OBJPROP_STYLE,Line_style);
         if(Line_displayType==1){ObjectSet(name,OBJPROP_BACK,false);}
         if(Line_displayType==2){ObjectSet(name,OBJPROP_BACK,true);}
         }
  if(Line_displayType==4){
   double gap  = 3.0*iATR(NULL,0,20,i)/3.0;   
        
      ObjectCreate(name,OBJ_ARROW,0,Time[shift],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_WIDTH,WidthLine);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[shift]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[shift] -gap);
}}
void DeleteLines()
{
   string lookFor       = ":";
   int    lookForLength = StringLen(lookFor);
   for (int shift=ObjectsTotal()-1; shift>=0; shift--)
   {
      string objectName = ObjectName(shift);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void DeleteLine(datetime time)
{
   string lookFor = ":"+time; ObjectDelete(lookFor);
}

 
  bool BarChanged()
  {
  static datetime dt = 0;

  if (dt != iTime(NULL,1,0))
  {
   dt = iTime(NULL,1,0);
   return(true);
  }
   return(false);
}
 


